// #autoload
// #name = KillSoundFX
// #version = 3.0
// #date = Feb 16, 2004
// #author = Bluez
// #description = Random kill sound effects, You can place your own wav sounds in the Audio/KillSoundFX folder and they will autoload the next time you start T2.
// #include = support/player_support.cs
// #include = support/callback.cs

if(!isObject(KillSoundFX)) {
	new scriptobject (KillSoundFX) {
		class = KillSoundFX;
        Wavcount = $Wavcount;
        Wavfile = $Wavfile;
	    };
}

if (!isfile("audio/KillSoundFX/KillSoundFX.txt")) {
	   %file = new FileObject();
       %file.openForWrite("audio/KillSoundFX/KillSoundFX.txt");
	   %file.writeLine("Place any wav here to use in conjunction with KillSoundFX....");
	   %file.close();
	   %file.delete();
}

if($pref::KillSoundFX_Active $= "")
   $pref::KillSoundFX_Active = true;
     
$VehicleWavList[0] = "fx/misc/crowd-clap.wav";
$VehicleWavList[1] = "KillSoundFX/horngoby.wav";
$VehicleWavList[2] = "KillSoundFX/beepbeep.wav";
$VehicleWavList[3] = "KillSoundFX/car_crash.wav";
$VehicleWavList[4] = "KillSoundFX/caroops.wav";
$VehicleWavList[5] = "KillSoundFX/baam.wav";
$VehicleWavList[6] = "KillSoundFX/hotbeef.wav";
$VehicleWavList[7] = "KillSoundFX/howdthatfeel.wav";
$VehicleWavList[8] = "KillSoundFX/tag.wav";
$VehicleWavList[9] = "KillSoundFX/ohshit.wav";

package KillSoundFX {
function Setup() {
         $Wavcount = 0;
         %WavLoc = "audio/KillSoundFX/*.wav";

          for($Wavfile = findFirstFile(%WavLoc); $Wavfile !$= ""; $Wavfile = findNextFile(%WavLoc)) {
              $WavList[$Wavcount] = $Wavfile;
              $WavList[$Wavcount] = getSubStr($WavList[$Wavcount], 6, strLen($WavList[$Wavcount]) - 6);
              $Wavcount++; }
}

function REGULAR() {
         if(!$pref::KillSoundFX_Active) return;
         
         %val = getRandom($Wavcount);
         %RandomWav = $WavList[%val];
         
         if(%killsound !$= "")
            alxStop(%killsound);
            
         %killsound = alxCreateSource("AudioGui", %RandomWav);
         alxPlay(%killsound);
}

function VEHICLE() {
         if(!$pref::KillSoundFX_Active) return;
         
         %val = getRandom(9);
         %VehicleWav = $VehicleWavList[%val];
         
         if(%killsound !$= "")
            alxStop(%killsound);
         
         %killsound = alxCreateSource("AudioGui", %VehicleWav);
         alxPlay(%killsound);
}

function RegularKill(%msgType, %msgString, %victimname, %vgen, %vposs, %killername, %kgen, %kposs, %damageType) {
         %client = PlayerList.getMyName();
         $clientname = detag(%client);
         %killerName = detag(%killerName);
         
         if(%killerName !$= $clientname) return;
         REGULAR();
}

function VehicleKill(%msgType, %msgString, %victimname, %vgen, %vposs, %killername, %kgen, %kposs, %damageType) {
         %client = PlayerList.getMyName();
         $clientname = detag(%client);
         %killerName = detag(%killerName);

         if(%killerName !$= $clientname) return;
         VEHICLE();
}

function OptionsDlg::onWake( %this ) {
        if (!$KillSoundFXToggle) {
			$RemapName[$RemapCount]="KillSoundFX ON/OFF";
			$RemapCmd[$RemapCount]="KillSoundFXToggle";
			$RemapCount++;
			$KillSoundFXToggle = true;
            }
            parent::onWake( %this );
}

function KillSoundFXToggle(%val) {
          if(!%val) return;

	   	  $pref::KillSoundFX_Active = !$pref::KillSoundFX_Active;
          addmessageHudline("\c1Kill SoundFX\c4" SPC ($pref::KillSoundFX_Active ? "ON" : "OFF"));
}

};
activatepackage(KillSoundFX);

            addMessageCallBack('MsgLegitKill', RegularKill);
            addMessageCallBack('MsgHeadshotKill', RegularKill);
            addMessageCallBack('msgExplosionKill', RegularKill);
            addMessageCallBack('msgTurretKill', RegularKill);
            addMessageCallBack('msgCTurretKill', RegularKill);
            addMessageCallBack('msgVehicleKill', VehicleKill);
            addMessageCallBack('msgHeadshot', RegularKill);
            addMessageCallBack('msgCarKill', RegularKill);
            addMessageCallBack('MsgRearshotKill', RegularKill);
            addMessageCallBack('msgOOBKill', RegularKill);

if(!$KillSoundFX::setup) {
         Setup();
         $KillSoundFX::setup = true;
}
